#include <amsclil1/amsclil1.h>

/////////////////////
//Utility Functions//
/////////////////////

static void _local_pblocations(size_t N, int64_t *padbytes, int64_t *padstart, int64_t *padstop, uint64_t *sz)
{
    int64_t N1 = N;

    if(N1%64LL >= 56LL)
    {
        *padbytes = ((N1/64LL)+2LL)*64LL;
        *padstart = N;
        *padstop = *padbytes-8;
        *sz = N*8;
    }
    else
    {
        *padbytes = ((N1/64LL)+1LL)*64LL;
        *padstart = N;
        *padstop = *padbytes-8;
        *sz = N*8;
    } 

    return;
}

static uint8_t _local_getpaddedbyte(const uint8_t *bytes, size_t Nin, size_t ind)
{
    uint8_t ret = 0;
    int64_t padbytes;
    int64_t padstart;
    int64_t padstop;
    uint64_t sz;

    uint64_t q;
    uint64_t mask;

    _local_pblocations(Nin,&padbytes,&padstart,&padstop,&sz);
    if(ind>padbytes)
    {
        ret = 0; return ret;
    }

    if(ind<padstart && ind<Nin)
    {
        ret = bytes[ind];
    }
    else if(ind==padstart)
    {
        ret = 0b10000000;
    }
    else if(ind>padstart && ind<padstop)
    {
        ret = 0;
    }
    else
    {
        //one byte of the padded byte size
        //0xaabb0111
        q = padbytes-ind-1; //7, 6, ... 0
        mask = 0x00000000000000ffLL;

        ret = (uint8_t)(sz&(mask<<(q/8LL))>>(q/8LL))
    }

    return ret;
}

static uint32_t _local_getpaddedui32(const uint8_t *bytes, size_t Nin, size_t ui32ind)
{
    uint32_t ret = 0;
    size_t N2;
    uint8_t b[4];

    if(ui32ind>padbytes/4)
    {
        ret = 0; return ret;
    }

    b[0] = _local_getpaddedbyte(bytes,Nin,ui32ind*4+0);
    b[1] = _local_getpaddedbyte(bytes,Nin,ui32ind*4+1);
    b[2] = _local_getpaddedbyte(bytes,Nin,ui32ind*4+2);
    b[3] = _local_getpaddedbyte(bytes,Nin,ui32ind*4+3);
    
    ret = ((uint32_t b[0])<<24) + ((uint32_t b[1])<<16) + ((uint32_t b[2])<<8) + ((uint32_t b[3])<<0)

    return ret;
}


/////////////////
//Main Function//
/////////////////

//MD5 Hash Algorithm
//Input: Some number of bytes in
//Output: 16 bytes (128 bits) digest out
int amsclil1_md5_hash(const uint8_t *bytes_in, size_t Nin, uint8_t *bytes16_out)
{
    int ret = 0;
    const uint8_t *pbytes = NULL; //I could do this without dynamic allocation, and it would be faster
    size_t npbytes = 0;
    size_t I;

    return ret;
}

/////////
//Tests//
/////////

//For "official answers", look at:
//  https://www.md5hashgenerator.com/



void amsclil1_md5_hash_tests()
{
    char str1[250];


    
    return;
}